import logging

from pathlib import Path
from alpinac.compound import Compound
from alpinac.io_tools import NISTMetadata, get_data_from_jdx_file, get_data_from_frag_file #, get_data_from_frag_unit_mass_file
from alpinac.utils_data_extraction import FitModes
from alpinac.validation.validation_utils import find_validation_idx_from_database
from alpinac.validation.mol_validation import mol_validation

import alpinac.const_identification as const_id
import networkx as nx


def initialization(
    path_file: Path,
) -> tuple[str | None, list[int], dict, NISTMetadata, float, bool]:
    logger = logging.getLogger('alpinac.mode_identfication.initialization')
    """Read input data from file depending on file format.

    Currently supports the txt files from alpinac peak extraction script.
    """ 
        
    logger.info('ALPINAC INIT: INITIALIZATION ')
    filename = path_file.name
    target_formula = None
    fragfile_name = None


    if path_file.suffix == ".jdx":
    #if "Mass" in filename: #instead, check if file is jdx format.
        # NIST unit-mass resolution data
        batch_fragments, nist_metadata = get_data_from_jdx_file(path_file)
        target_formula = str(nist_metadata.target_formula)
        if target_formula == "None" or target_formula == "none" or target_formula == "":
            target_formula = None

    elif path_file.suffix in [".txt", ".csv"]:
        # std. file generated by TOFWerk data        
        toffile_name = path_file.stem # the filename without extension (.txt)
        logger.info("toffile_name = {}".format(toffile_name))
        # this is not a general way to get the compound name: TODO
        if '.frag.' in toffile_name:
            # Take what comes after the frag
            # = what was generated by the mode extraction script 
            fragfile_name = toffile_name.split('.frag.')[-1]
            # Remove the '.txt'
            fragfile_name = fragfile_name[:-4]
            logger.info(fragfile_name)
        
        toffile_name_split = toffile_name.split(".")
        for i_string in range(len(toffile_name_split)):
            if toffile_name_split[i_string] == "known":
                fragfile_name = toffile_name_split[i_string+1]

        if fragfile_name is not None:
            logger.info('Compound: ' + fragfile_name)
            

        if fragfile_name is not None and ('known_' in fragfile_name or ".known." in toffile_name):
            #use formula from validation database
            #the knapsack will generation only fragments from the set formula
            #(adding adducts if the "adduct" column is not None)
            #!! Note MYGU 2022.05.19
            #This is really not elegant.
            #Would it be better to have a vaiable as header in the input file
            #potentially giving the input "true" formula to use?
            idx_val = find_validation_idx_from_database(fragfile_name, mol_validation)
            target_elements = None
            if idx_val is not None:
                target_formula = mol_validation[idx_val]["Sum formula"]
                const_id_max_opt_signal = min(const_id.max_opt_signal, 99.0)
                const_id_max_ratio_not_opt_masses = min(const_id.max_ratio_not_opt_masses, 0.00)
            else:
                target_formula = None
            
            logger.warn(">>>Treat as known compound, target formula: " + target_formula)
                
        batch_fragments = get_data_from_frag_file(path_file)

        """
        if show_plt_figures:
            try:
                plot_mass_defect_of_fragments(batch_fragments, toffile_name, fig_file=None, show=True)
            except:
                logger.info("No figure of mass defect.")
        """
        
        
    else:
        logger.info('ALPINAC INIT: file format not regognise, accepted formats are .jx or .txt. ')
        raise ValueError('ALPINAC INIT: file format not regognise, accepted formats are .jx or .txt. ')
        





    # get the keys of the dictionary that are the fragment indices:
    list_frag_idx = [i for i in batch_fragments if i != -1]


    const_id_max_opt_signal = const_id.max_opt_signal
    const_id_max_ratio_not_opt_masses = const_id.max_ratio_not_opt_masses



    if 'train_' in filename or 'val_' in filename or 'known_' in filename:
        do_val = True
    else:
        do_val = False
    





    return (
        target_formula,
        list_frag_idx,
        batch_fragments,
        const_id_max_opt_signal,
        do_val
    )

   




def step_initialize_compound(
    batch_fragments:dict,
    compound_number:int,
    ):
    logger = logging.getLogger('alpinac.mode_identfication.step_initialization_compound')


    cl_comp = Compound(
        batch_fragments[compound_number],
        compound_number, 
        const_id.LOD
    )

    const_id_min_detect_mass = min(min(cl_comp.meas_mass), const_id.min_detect_mass)

    #elif run_type.is_NIST():

    #    cl_comp = CompoundNIST(
    #        batch_fragments[compound_number], 
    #        compound_number, 
    #        const_id.LOD)

    #    logger.info('***LOD***: ' + str(cl_comp.LOD))
    #    const_id_min_detect_mass = min(10.0, min(cl_comp.meas_mass)) #24 if ToF APRECON
    #    const_id_max_ratio_not_opt_masses = 0.0 #force to iterate through all measured masses, TODO will be overwritten later
    #    logger.info("test NIST assigned ionisation")
    #    logger.debug(cl_comp.ionisation)


    return cl_comp, const_id_min_detect_mass 

    